diff --git a/Makefile.objs b/Makefile.objs
index 8d23fbb..bab4b3f 100644
--- a/Makefile.objs
+++ b/Makefile.objs
@@ -276,7 +276,7 @@ hw-obj-$(CONFIG_AHCI) += ide/ich.o
 hw-obj-$(CONFIG_LSI_SCSI_PCI) += lsi53c895a.o
 hw-obj-$(CONFIG_ESP) += esp.o
 
-hw-obj-y += dma-helpers.o sysbus.o isa-bus.o
+hw-obj-y += dma-helpers.o sysbus.o isa-bus.o isa-bridge.o
 hw-obj-y += qdev-addr.o
 
 # VGA
diff --git a/hw/isa-bridge.c b/hw/isa-bridge.c
new file mode 100644
index 0000000..6f51701
--- /dev/null
+++ b/hw/isa-bridge.c
@@ -0,0 +1,85 @@
+/*
+ * Simple ISA bus bridge
+ *
+ * Copyright (c) 2011 Herve Poussineau
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "isa.h"
+#include "sysbus.h"
+
+typedef struct {
+    SysBusDevice busdev;
+    ISABus bus;
+    qemu_irq *irqs;
+    MemoryRegion *io_space;
+} ISABridgeSysBusState;
+
+static void isabus_bridge_set_irqs(ISABus *bus, qemu_irq *irqs)
+{
+    ISABridgeSysBusState *s = container_of(bus, ISABridgeSysBusState, bus);
+    s->irqs = irqs;
+}
+
+static qemu_irq isabus_bridge_get_irq(ISABus *bus, int isairq)
+{
+    ISABridgeSysBusState *s = container_of(bus, ISABridgeSysBusState, bus);
+    if (!s->irqs || isairq < 0 || isairq > 15) {
+        hw_error("isa irq %d invalid", isairq);
+    }
+    return s->irqs[isairq];
+}
+
+static void isa_bridge_set_io_space(ISABus *bus, MemoryRegion* io_space)
+{
+    ISABridgeSysBusState *s = container_of(bus, ISABridgeSysBusState, bus);
+    s->io_space = io_space;
+}
+
+static MemoryRegion *isa_bridge_get_io_space(ISABus *bus)
+{
+    ISABridgeSysBusState *s = container_of(bus, ISABridgeSysBusState, bus);
+    return s->io_space;
+}
+
+static ISABusOps isabus_bridge_ops = {
+    .set_irqs = isabus_bridge_set_irqs,
+    .get_irq = isabus_bridge_get_irq,
+    .set_io_space = isa_bridge_set_io_space,
+    .get_io_space = isa_bridge_get_io_space,
+};
+
+static int isabus_bridge_init(SysBusDevice *dev)
+{
+    ISABridgeSysBusState *isa = FROM_SYSBUS(ISABridgeSysBusState, dev);
+    isa_bus_new(&isa->bus, &isabus_bridge_ops, &dev->qdev);
+    return 0;
+}
+
+static SysBusDeviceInfo isabus_bridge_info = {
+    .init = isabus_bridge_init,
+    .qdev.name  = "isabus-bridge",
+    .qdev.fw_name  = "isa",
+    .qdev.size  = sizeof(ISABridgeSysBusState),
+    .qdev.no_user = 1,
+};
+
+static void isabus_bridge_register_devices(void)
+{
+    sysbus_register_withprop(&isabus_bridge_info);
+}
+
+device_init(isabus_bridge_register_devices)
+
diff --git a/hw/isa-bus.c b/hw/isa-bus.c
index ad225c6..f8b5dcb 100644
--- a/hw/isa-bus.c
+++ b/hw/isa-bus.c
@@ -22,13 +22,10 @@
 #include "isa.h"
 #include "exec-memory.h"
 
-struct ISABus {
-    BusState qbus;
-    MemoryRegion *address_space_io;
-    qemu_irq *irqs;
-};
 static ISABus *isabus;
 target_phys_addr_t isa_mem_base = 0;
+static qemu_irq *isa_bus_default_irqs;
+static MemoryRegion *isa_bus_io_space;
 
 static void isabus_dev_print(Monitor *mon, DeviceState *dev, int indent);
 static char *isabus_get_fw_dev_path(DeviceState *dev);
@@ -40,6 +37,36 @@ static struct BusInfo isa_bus_info = {
     .get_fw_dev_path = isabus_get_fw_dev_path,
 };
 
+static void isa_bus_default_set_irqs(ISABus *bus, qemu_irq *irqs)
+{
+    isa_bus_default_irqs = irqs;
+}
+
+static qemu_irq isa_bus_default_get_irq(ISABus *bus, int isairq)
+{
+    if (isairq < 0 || isairq > 15) {
+        hw_error("isa irq %d invalid", isairq);
+    }
+    return isa_bus_default_irqs[isairq];
+}
+
+static void isa_bus_default_set_io_space(ISABus *bus, MemoryRegion *io_space)
+{
+    isa_bus_io_space = io_space;
+}
+
+static MemoryRegion *isa_bus_default_get_io_space(ISABus *bus)
+{
+    return isa_bus_io_space;
+}
+
+static ISABusOps isa_bus_default_ops = {
+    .set_irqs = isa_bus_default_set_irqs,
+    .get_irq = isa_bus_default_get_irq,
+    .set_io_space = isa_bus_default_set_io_space,
+    .get_io_space = isa_bus_default_get_io_space,
+};
+
 ISABus *isa_bus_bridge_init(DeviceState *dev, MemoryRegion *address_space_io)
 {
     if (isabus) {
@@ -49,16 +76,32 @@ ISABus *isa_bus_bridge_init(DeviceState *dev, MemoryRegion *address_space_io)
     if (NULL == dev) {
         dev = qdev_create(NULL, "isabus-bridge");
         qdev_init_nofail(dev);
+    } else {
+        isabus = FROM_QBUS(ISABus, qbus_create(&isa_bus_info, dev, NULL));
+        isabus->ops = &isa_bus_default_ops;
     }
 
-    isabus = FROM_QBUS(ISABus, qbus_create(&isa_bus_info, dev, NULL));
-    isabus->address_space_io = address_space_io;
+    isabus->ops->set_io_space(isabus, address_space_io);
+
     return isabus;
 }
 
+void isa_bus_new(ISABus *bus, ISABusOps *ops, DeviceState *host)
+{
+    if (isabus) {
+        hw_error("Can't create a second ISA bus");
+    }
+    qbus_create_inplace(&bus->qbus, &isa_bus_info, host, NULL);
+    bus->ops = ops;
+    isabus = bus;
+}
+
 void isa_bus_irqs(qemu_irq *irqs)
 {
-    isabus->irqs = irqs;
+    if (!isabus || !isabus->ops->set_irqs) {
+        hw_error("Tried to set isa irqs with no isa bus present.");
+    }
+    isabus->ops->set_irqs(isabus, irqs);
 }
 
 /*
@@ -69,10 +112,10 @@ void isa_bus_irqs(qemu_irq *irqs)
  */
 qemu_irq isa_get_irq(int isairq)
 {
-    if (isairq < 0 || isairq > 15) {
-        hw_error("isa irq %d invalid", isairq);
+    if (!isabus || !isabus->ops->get_irq) {
+        hw_error("ISA bus invalid");
     }
-    return isabus->irqs[isairq];
+    return isabus->ops->get_irq(isabus, isairq);
 }
 
 void isa_init_irq(ISADevice *dev, qemu_irq *p, int isairq)
@@ -110,7 +153,13 @@ void isa_init_ioport(ISADevice *dev, uint16_t ioport)
 
 void isa_register_ioport(ISADevice *dev, MemoryRegion *io, uint16_t start)
 {
-    memory_region_add_subregion(isabus->address_space_io, start, io);
+    ISABus *bus = isabus;
+
+    if (!bus || !bus->ops->get_io_space) {
+        hw_error("Tried to register I/O port with no isa bus present.");
+    }
+
+    memory_region_add_subregion(bus->ops->get_io_space(bus), start, io);
     if (dev != NULL) {
         assert(dev->nio < ARRAY_SIZE(dev->io));
         dev->io[dev->nio++] = io;
@@ -182,25 +231,6 @@ static void isabus_dev_print(Monitor *mon, DeviceState *dev, int indent)
     }
 }
 
-static int isabus_bridge_init(SysBusDevice *dev)
-{
-    /* nothing */
-    return 0;
-}
-
-static SysBusDeviceInfo isabus_bridge_info = {
-    .init = isabus_bridge_init,
-    .qdev.name  = "isabus-bridge",
-    .qdev.fw_name  = "isa",
-    .qdev.size  = sizeof(SysBusDevice),
-    .qdev.no_user = 1,
-};
-
-static void isabus_register_devices(void)
-{
-    sysbus_register_withprop(&isabus_bridge_info);
-}
-
 static char *isabus_get_fw_dev_path(DeviceState *dev)
 {
     ISADevice *d = (ISADevice*)dev;
@@ -220,4 +250,3 @@ MemoryRegion *isa_address_space(ISADevice *dev)
     return get_system_memory();
 }
 
-device_init(isabus_register_devices)
diff --git a/hw/isa.h b/hw/isa.h
index d2b3cba..3437199 100644
--- a/hw/isa.h
+++ b/hw/isa.h
@@ -7,7 +7,7 @@
 #include "memory.h"
 #include "qdev.h"
 
-typedef struct ISABus ISABus;
+typedef struct ISABusOps ISABusOps;
 typedef struct ISADevice ISADevice;
 typedef struct ISADeviceInfo ISADeviceInfo;
 
@@ -27,7 +27,23 @@ struct ISADeviceInfo {
     isa_qdev_initfn init;
 };
 
+/* isa-bus.c */
+
+struct ISABus {
+    BusState qbus;
+    ISABusOps *ops;
+};
+
+struct ISABusOps {
+    void (*set_irqs)(ISABus *bus, qemu_irq *irqs);
+    qemu_irq (*get_irq)(ISABus *bus, int isairq);
+    void (*set_io_space)(ISABus *bus, MemoryRegion *address_space);
+    MemoryRegion *(*get_io_space)(ISABus *bus);
+};
+
 ISABus *isa_bus_bridge_init(DeviceState *dev, MemoryRegion *address_space_io);
+
+void isa_bus_new(ISABus *bus, ISABusOps *ops, DeviceState *host);
 void isa_bus_irqs(qemu_irq *irqs);
 qemu_irq isa_get_irq(int isairq);
 void isa_init_irq(ISADevice *dev, qemu_irq *p, int isairq);
diff --git a/qemu-common.h b/qemu-common.h
index 5e87bdf..e3a470d 100644
--- a/qemu-common.h
+++ b/qemu-common.h
@@ -243,6 +243,7 @@ typedef struct VLANClientState VLANClientState;
 typedef struct i2c_bus i2c_bus;
 typedef struct i2c_slave i2c_slave;
 typedef struct SMBusDevice SMBusDevice;
+typedef struct ISABus ISABus;
 typedef struct PCIHostState PCIHostState;
 typedef struct PCIExpressHost PCIExpressHost;
 typedef struct PCIBus PCIBus;